<template>
  <div>
    <v-toolbar
      flat
      height="100px"
      color="primary"
    >
      <v-toolbar-title align="middle">
        <a
          href="/"
          class="d-flex align-center"
        >
          <v-img
            class="logo"
            :src="imageLink + 'caf38-logo.png'"
            alt="Caf38"
            height="90"
            contain
            eager
          />
        </a>
      </v-toolbar-title>

      <v-spacer />
      <div v-if="user">
        <MMessageBtn :unread-message-number="unreadMessageNumber" />
        <MHeaderProfile
          :avatar="user.avatars[0]"
          :short-family-name="(user.shortFamilyName) ? user.givenName+' '+user.shortFamilyName : '-'"
          :text-color-class="'font-weight-bold white--text'"
          :links-color-class="'black--text'"
        />
      </div>
      <div v-else>
        <v-btn
          rounded
          text
          :href="$t('buttons.signup.route')"
          class="font-weight-bold white--text"
        >
          {{ $t('buttons.signup.label') }}
        </v-btn>
        <v-btn
          rounded
          text
          :href="$t('buttons.logIn.route')"
          class="font-weight-bold white--text"
        >
          {{ $t('buttons.logIn.label') }}
        </v-btn>
      </div>
      <v-btn
        rounded
        dark
        :disabled="!user"
        :href="$t('buttons.shareAnAd.route')"
        class="white--text font-weight-bold"
        color="secondary"
        elevation="0"
      >
        {{ $t('buttons.shareAnAd.label') }}
      </v-btn>
      <MHeaderLanguage
        text-class="white--text font-weight-bold"
        :languages="languages"
        :language="dlocale"
        @languageSelected="updateLanguage"
      />
    </v-toolbar>
    <GamificationNotifications :user-gamification-notifications="(user && user.gamificationNotifications) ? user.gamificationNotifications : null" />
    <GratuityNotifications :user-gratuity-notifications="(user && user.gratuityNotifications) ? user.gratuityNotifications : null" />
    <!-- legal guardian dialog -->
    <v-dialog
      v-if="user"
      v-model="activeLegalGuardianDialog"
      persistent
      max-width="900"
    >
      <v-card>
        <v-card-title
          class="text-h5 justify-center"
        >
          {{ $t('dialog.parentalConsent.title') }}
        </v-card-title>
        <v-card-text v-html="$t('dialog.parentalConsent.content',{'legalGuardianEmail':user.legalGuardianEmail})" />
        <v-card-actions>
          <v-spacer />
          <v-btn
            color="secondary"
            primary
            rounded
            :href="this.$t('buttons.logOut.route')"
          >
            {{ $t('dialog.parentalConsent.buttonLabel') }}
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>  
  </div>
</template>

<script>
import { merge, has } from "lodash";
import { messages_en, messages_fr, messages_eu} from "@translations/components/base/MHeader/";
import { messages_client_en, messages_client_fr, messages_client_eu} from "@clientTranslations/components/base/MHeader/";
import MHeaderProfile from "@components/base/MHeaderProfile.vue";
import MHeaderLanguage from "@components/base/MHeaderLanguage.vue";
import MMessageBtn from "@components/base/MMessageBtn.vue";
import GamificationNotifications from "@components/utilities/gamification/GamificationNotifications";
import GratuityNotifications from "@components/utilities/gratuity/GratuityNotifications";

let MessagesMergedEn = merge(messages_en, messages_client_en);
let MessagesMergedFr = merge(messages_fr, messages_client_fr);
let MessagesMergedEu = merge(messages_eu, messages_client_eu);

export default {
  i18n: {
    messages: {
      'en': MessagesMergedEn,
      'fr': MessagesMergedFr,
      'eu': MessagesMergedEu
    },
  },
  components: {
    MHeaderProfile,
    MHeaderLanguage,
    MMessageBtn,
    GamificationNotifications,
    GratuityNotifications
  },
  props: {
    user: {
      type: Object,
      default: null
    },
    locale: {
      type: String,
      default: "fr"
    },
    languages: {
      type: Object,
      default: () => {}
    },
    token: {
      type: String,
      default: ''
    },
    gamificationActive:{
      type: Boolean,
      default: false
    }
  },
  data () {
    return {
      imageLink: "/images/pages/home/",
      width: 0,
      snackbar: null,
      defaultLocale: 'fr',
      dlocale: this.locale,
      activeLegalGuardianDialog: false
    }
  },
  computed:{
    unreadMessageNumber(){
      return this.user.unreadCarpoolMessageNumber + this.user.unreadDirectMessageNumber + this.user.unreadSolidaryMessageNumber; 
    }
  },
  mounted() {
    if (has(this.languages, this.locale)) {
      this.dlocale = this.locale;
    } else {
      this.dlocale = this.defaultLocale;
    }
    this.$store.commit('g/setActive',this.gamificationActive);
    this.$store.commit('grt/setActive',this.gratuityActive);
  },
  created() {
    this.$store.commit('a/setToken',this.user?.token ? this.user.token : this.token);
    if(this.user){
      localStorage.setItem('X-LOCALE',this.dlocale);
    }
    if(this.user?.needParentalConsent) {
      this.activeLegalGuardianDialog = true;
    }
    this.$root.$i18n.locale = this.dlocale
  },
  methods:{
    updateLanguage(language) {
      this.$root.$i18n.locale = language
    },
  }
};
</script>